// FileDialogAddInDlg.cpp : implementation file
//

#include "stdafx.h"
#include "FileDialogAddIn.h"
#include "FileDialogAddInDlg.h"
#include "CodeViewDlg.h"

#include <afxdlgs.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFileDialogAddInDlg dialog


CFileDialogAddInDlg::CFileDialogAddInDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFileDialogAddInDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFileDialogAddInDlg)
	m_cVariableName = _T("cFileDlg");
	m_sFilters = _T("All Files (*.*)|*.*|");
	m_sParent = _T("this");
	m_sCaption = _T("");
	m_sExt = _T("");
	m_sInitDir = _T("");
	m_sInitFilename = _T("");
	m_bSizing = TRUE;
	m_bExplorer = TRUE;
	m_bAllowLongFilenames = TRUE;
	m_bOverwritePrompt = TRUE;
	m_bPromptCreate = TRUE;
	m_bAllowMulti = FALSE;
	m_bEnableHook = FALSE;
	m_bEnableTemplate = FALSE;
	m_bEnableTemplateHandle = FALSE;
	m_bHideReadOnly = FALSE;
	m_bInitReadOnly = FALSE;
	m_bMustExist = FALSE;
	m_bNoChangeDir = FALSE;
	m_bNoDerefLinks = FALSE;
	m_bNoLongFileNames = FALSE;
	m_bNoNetworkButton = FALSE;
	m_bNoReadOnly = FALSE;
	m_bNoTestCreate = FALSE;
	m_bNoValidate = FALSE;
	m_bPathMustExist = FALSE;
	m_bShareAware = FALSE;
	m_bShowHelp = FALSE;
	//}}AFX_DATA_INIT
}


void CFileDialogAddInDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFileDialogAddInDlg)
	DDX_Text(pDX, IDC_EDIT_CAPTION, m_sCaption);
	DDX_Text(pDX, IDC_EDIT_DEFAULT_EXTENTION, m_sExt);
	DDX_Text(pDX, IDC_EDIT_FILTERS, m_sFilters);
	DDX_Text(pDX, IDC_EDIT_INITIAL_DIRECTORY, m_sInitDir);
	DDX_Text(pDX, IDC_EDIT_INITIAL_FILENAME, m_sInitFilename);
	DDX_Text(pDX, IDC_EDIT_PARENT, m_sParent);
	DDX_Check(pDX, IDC_CHECK_SIZING, m_bSizing);
	DDX_Check(pDX, IDC_CHECK_ALLOW_MULTI, m_bAllowMulti);
	DDX_Check(pDX, IDC_CHECK_ENABLE_HOOK, m_bEnableHook);
	DDX_Check(pDX, IDC_CHECK_ENABLE_TEMPLATE, m_bEnableTemplate);
	DDX_Check(pDX, IDC_CHECK_ENABLE_TEMPLATE_HANDLE, m_bEnableTemplateHandle);
	DDX_Check(pDX, IDC_CHECK_EXPLORER, m_bExplorer);
	DDX_Check(pDX, IDC_CHECK_HIDE_READ_ONLY, m_bHideReadOnly);
	DDX_Check(pDX, IDC_CHECK_INITIAL_READ_ONLY_CHECK, m_bInitReadOnly);
	DDX_Check(pDX, IDC_CHECK_MUSTEXIST, m_bMustExist);
	DDX_Check(pDX, IDC_CHECK_NO_CHANGE_DIR, m_bNoChangeDir);
	DDX_Check(pDX, IDC_CHECK_NO_DEREF_LINKS, m_bNoDerefLinks);
	DDX_Check(pDX, IDC_CHECK_NO_LONG_FILENAMES, m_bNoLongFileNames);
	DDX_Check(pDX, IDC_CHECK_NO_NETWORK_BTN, m_bNoNetworkButton);
	DDX_Check(pDX, IDC_CHECK_NO_READ_ONLY, m_bNoReadOnly);
	DDX_Check(pDX, IDC_CHECK_NO_TEST_FILE_CREATE, m_bNoTestCreate);
	DDX_Check(pDX, IDC_CHECK_NO_VALIDATE, m_bNoValidate);
	DDX_Check(pDX, IDC_CHECK_OVERWRITE_PROMPT, m_bOverwritePrompt);
	DDX_Check(pDX, IDC_CHECK_PATH_MUST_EXIST, m_bPathMustExist);
	DDX_Check(pDX, IDC_CHECK_PROMPT_CREATE, m_bPromptCreate);
	DDX_Check(pDX, IDC_CHECK_SHARE_AWARE, m_bShareAware);
	DDX_Check(pDX, IDC_CHECK_SHOW_HELP, m_bShowHelp);
	DDX_Check(pDX, IDC_CHECK_ALLOW_LONG_FILENAMES, m_bAllowLongFilenames);
	DDX_Text(pDX, IDC_EDIT_VARIABLE_NAME, m_cVariableName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFileDialogAddInDlg, CDialog)
	//{{AFX_MSG_MAP(CFileDialogAddInDlg)
	ON_BN_CLICKED(IDC_BUTTON_CANCEL, OnButtonCancel)
	ON_BN_CLICKED(IDC_BUTTON_CLIPBOARD, OnButtonClipboard)
	ON_BN_CLICKED(IDC_BUTTON_CODE, OnButtonCode)
	ON_BN_CLICKED(IDC_BUTTON_TEST, OnButtonTest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFileDialogAddInDlg message handlers

void CFileDialogAddInDlg::OnButtonCancel() 
{
	CDialog::OnCancel();
}

void CFileDialogAddInDlg::OnButtonClipboard() 
{
	UpdateData(TRUE);

	CString cCode = GetCodeString();

    HGLOBAL hMem = ::GlobalAlloc(GMEM_MOVEABLE|GMEM_DDESHARE, lstrlen((LPCSTR)cCode)+1);
	if(!hMem)
		return;

	lstrcpy((LPSTR)::GlobalLock(hMem), (LPCSTR)cCode);
	::GlobalUnlock(hMem);
   	OpenClipboard();
   	EmptyClipboard();
	SetClipboardData(CF_TEXT, hMem);
   	CloseClipboard();

	CDialog::OnOK();
}

void CFileDialogAddInDlg::OnButtonCode() 
{
	UpdateData(TRUE);

	CCodeViewDlg dlg(this);
	dlg.m_cCode = GetCodeString();
	dlg.DoModal();
}

void CFileDialogAddInDlg::OnButtonTest() 
{
	UpdateData(TRUE);
	CFileDialog dlg( ((CButton *) GetDlgItem(IDC_RADIO_OPEN))->GetCheck(),
		(m_sExt.IsEmpty() ? (LPCTSTR)NULL : m_sExt),
		(m_sInitFilename.IsEmpty() ? (LPCTSTR)NULL : m_sInitFilename),
		GetDWFlags(),
		(m_sFilters.IsEmpty() ? (LPCTSTR)NULL : m_sFilters),
		this );
	dlg.m_ofn.lpstrInitialDir = m_sInitDir;
	dlg.m_ofn.lpstrTitle = m_sCaption;

	dlg.DoModal();
}

BOOL CFileDialogAddInDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	((CButton *) GetDlgItem(IDC_RADIO_OPEN))->SetCheck(1);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

CString CFileDialogAddInDlg::GetCodeString()
{
	CString cCode = _T("CFileDialog ");
	cCode += m_cVariableName;
	cCode += _T(" (\r\n\t");
	cCode += (((CButton *) GetDlgItem(IDC_RADIO_OPEN))->GetCheck() ? "TRUE" : "FALSE");
	cCode += _T(", \r\n\t");

	if (m_sExt.IsEmpty()) cCode += _T("(LPCTSTR)NULL");
	else cCode += _T("_T(\"") + m_sExt + _T("\")");
	cCode += _T(", \r\n\t");

	if (m_sInitFilename.IsEmpty()) cCode += _T("(LPCTSTR)NULL");
	else cCode += _T("_T(\"") + m_sInitFilename + _T("\")");
	cCode += _T(", \r\n\t");

	cCode += GetDWFlagsString();
	cCode += _T(", \r\n\t");
	if (m_sFilters.IsEmpty()) cCode += _T("(LPCTSTR)NULL");
	else cCode += _T("_T(\"") + m_sFilters + _T("\")");
	cCode += _T(", \r\n\t");

	cCode += (m_sParent.IsEmpty() ? _T("(LPCTSTR)NULL") : m_sParent);
	cCode += _T(" );\r\n");

	if (!m_sInitDir.IsEmpty())
	{
		cCode += _T("cFileDlg.m_ofn.lpstrInitialDir = _T(\"");
		cCode += m_sInitDir;
		cCode += _T("\");\r\n");
	}
	if (!m_sCaption.IsEmpty())
	{
		cCode += _T("cFileDlg.m_ofn.lpstrTitle = _T(\"");
		cCode += m_sCaption;
		cCode += _T("\");");
	}

	if (m_bEnableTemplate)
		cCode += _T("\r\n// TODO: set the template name\r\n//cFileDlg.m_ofn.lpTemplateName = ;");
	if (m_bEnableTemplateHandle)
		cCode += _T("\r\n// TODO: set the template handle\r\n//cFileDlg.m_ofn.hInstance = ;");
	if (m_bShowHelp)
		cCode += _T("\r\n// TODO: set the help hwnd\r\n//cFileDlg.m_ofn.hwndOwner = ;");
	if (m_bEnableHook)
		cCode += _T("\r\n// TODO: set the hook function\r\n//cFileDlg.m_ofn.lpfnHook = ;");

	return cCode;
}
DWORD CFileDialogAddInDlg::GetDWFlags()
{
	return ( (m_bSizing ? OFN_ENABLESIZING : 0) | 
		(m_bAllowMulti ? OFN_ALLOWMULTISELECT : 0) |
		(m_bEnableHook ? OFN_ENABLEHOOK : 0) |
		(m_bExplorer ? OFN_EXPLORER : 0) |
		(m_bHideReadOnly ? OFN_HIDEREADONLY : 0) |
		(m_bInitReadOnly ? OFN_READONLY : 0) |
		(m_bMustExist ? OFN_PATHMUSTEXIST : 0) |
		(m_bNoChangeDir ? OFN_NOCHANGEDIR : 0) |
		(m_bNoDerefLinks ? OFN_NODEREFERENCELINKS : 0) |
		(m_bNoLongFileNames ? OFN_NOLONGNAMES : 0) |
		(m_bAllowLongFilenames ? OFN_LONGNAMES : 0) |
		(m_bNoNetworkButton ? OFN_NONETWORKBUTTON : 0) |
		(m_bNoReadOnly ? OFN_NOREADONLYRETURN : 0) |
		(m_bNoTestCreate ? OFN_NOTESTFILECREATE : 0) |
		(m_bNoValidate ? OFN_NOVALIDATE : 0) |
		(m_bOverwritePrompt ? OFN_OVERWRITEPROMPT : 0) |
		(m_bPathMustExist ? OFN_PATHMUSTEXIST : 0) |
		(m_bPromptCreate ? OFN_CREATEPROMPT : 0) |
		(m_bShareAware ? OFN_SHAREAWARE : 0) |
		(m_bShowHelp ? OFN_SHOWHELP : 0) );
}
CString CFileDialogAddInDlg::GetDWFlagsString()
{
	CString sRet = _T("");
	
	if (m_bSizing)	sRet += _T("OFN_ENABLESIZING|");
	if (m_bAllowMulti) sRet += _T("OFN_ALLOWMULTISELECT|");
	if (m_bEnableHook) sRet += _T("OFN_ENABLEHOOK|");
	if (m_bEnableTemplate) sRet += _T("OFN_ENABLETEMPLATE|");
	if (m_bEnableTemplateHandle) sRet += _T("OFN_ENABLETEMPLATEHANDLE|");
	if (m_bExplorer) sRet += _T("OFN_EXPLORER|");
	if (m_bHideReadOnly) sRet += _T("OFN_HIDEREADONLY|");
	if (m_bInitReadOnly) sRet += _T("OFN_READONLY|");
	if (m_bMustExist) sRet += _T("OFN_PATHMUSTEXIST|");
	if (m_bNoChangeDir) sRet += _T("OFN_NOCHANGEDIR|");
	if (m_bNoDerefLinks) sRet += _T("OFN_NODEREFERENCELINKS|");
	if (m_bNoLongFileNames) sRet += _T("OFN_NOLONGNAMES|");
	if (m_bAllowLongFilenames) sRet += _T("OFN_LONGNAMES|");
	if (m_bNoNetworkButton) sRet += _T("OFN_NONETWORKBUTTON|");
	if (m_bNoReadOnly) sRet += _T("OFN_NOREADONLYRETURN|");
	if (m_bNoTestCreate) sRet += _T("OFN_NOTESTFILECREATE|");
	if (m_bNoValidate) sRet += _T("OFN_NOVALIDATE|");
	if (m_bOverwritePrompt) sRet += _T("OFN_OVERWRITEPROMPT|");
	if (m_bPathMustExist) sRet += _T("OFN_PATHMUSTEXIST|");
	if (m_bPromptCreate) sRet += _T("OFN_CREATEPROMPT|");
	if (m_bShareAware) sRet += _T("OFN_SHAREAWARE|");
	if (m_bShowHelp) sRet += _T("OFN_SHOWHELP|");

	if (sRet.IsEmpty()) sRet = _T("0");
	else sRet = sRet.Left(sRet.GetLength()-1);

	return sRet;
}